// Header File
// Created 10.02.2008; 15:24:59

// Copyright  2002 TICT.
// Credits go to:
// - 'hibou' (Nicolas Laleve) for improving the original functions in his
//   program HibText, and giving me the idea to implement them slightly
//   differently.
// - 'nEUrOne' for pointing me that his functions written in assembly were
//   faster. I had a look at what GCC assembled for these functions, and saw
//   that there were two transfers to memory in the functions using masks,
//   while one was enough (that was not GCC's fault but Tom's and my fault)... 
//   Then, I rewrote these functions, that decreased  size and improved speed.
//   After that, I decided to rewrite all functions in plain assembly...

// These functions are not designed to write in planes that are not of the
// screen size ! That's because the space between two lines is hard-coded...
// Clipping and word-wrap are NOT implemented !

// CAUTION: The functions will do what you want them to do, even if you give
// them a font number for which the font address was not retrieved...
// This is very likely to end in a crash !

#ifndef FASTSTRING_H
#define FASTSTRING_H

// by TICT
void FS_DrawString(register short asm("%d0"),register short asm("%d1"),register const unsigned char* 
asm("%a0"),register void* asm("%a1"),register short asm("%d2"));

short SetupCharSet(void);

void FS_GrayDrawString(short,short,const char*,short,short);
//void FS_GrayDrawString2B(short x,short y,const char *s,short attr,short font,void *plane0,void *plane1);

extern unsigned char* __FontsTable__;
extern unsigned char* __F_4x6_Font__;
extern unsigned char* __F_6x8_Font__;
extern unsigned char* __F_8x10_Font__;

//static unsigned char __Factors__[3]={6,8,10};
//extern unsigned char __table_MaskLS__[];

//static short Factors[]={6,8,10};

#endif // FASTSTRING_H